Subject: Re: [PATCH net v2] switchdev: don't abort hardware ipv4 fib offload on failure to program fib entry in hardware

From: John Fastabend <[email-masked]>
Date: Mon, 18 May 2015 17:21:29 -0700

On 05/18/2015 01:19 PM, David Miller wrote:
> From: Roopa Prabhu <[email-masked]>
> Date: Sun, 17 May 2015 16:42:05 -0700
> 
>> On most systems where you can offload routes to hardware,
>> doing routing in software is not an option (the cpu limitations
>> make routing impossible in software).
> 
> You absolutely do not get to determine this policy, none of us
> do.
> 
> What matters is that by default the damn switch device being there
> is %100 transparent to the user.
> 
> And the way to achieve that default is to do software routes as
> a fallback.
> 

Although this is not really usable for a class of switches this way,
as noted above.

> I am not going to entertain changes of this nature which fail
> route loading by default just because we've exceeded a device's
> HW capacity to offload.
> 
> I thought I was _really_ clear about this at netdev 0.1

So how about having an error strategy sysctl field that we can set
at provisioning time. I think this would align to Roopa's option (b).
This way we can default to "transparent" mode and the users where
this wont work can set the error mode. This way user land software
stacks that work today should continue to work in both modes.

.John